"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
class CmdError extends Error {
}
exports.CmdError = CmdError;
function sh(options) {
    return new Promise((resolve, reject) => {
        if (!options.cmd) {
            throw new CmdError('Parameted cmd is required and should be specified');
        }
        let cmd = options.cmd;
        const error = [];
        const args = options.args;
        const dir = options.cwd || process.cwd();
        const out = [];
        if (/^win/.test(process.platform)) {
            args.unshift(cmd);
            args.unshift('/c');
            cmd = 'cmd.exe';
        }
        const command = child_process_1.spawn(cmd, args, {
            cwd: dir
        });
        command.stdout.on('data', data => {
            out.push(data.toString());
        });
        command.stderr.on('data', data => {
            error.push(data.toString() + '\n');
        });
        command.on('exit', code => {
            resolve({
                status: code,
                stdout: out.join(''),
                stderr: error.join('')
            });
        });
    });
}
exports.sh = sh;
//# sourceMappingURL=cmd.js.map